'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RIGHT_ALIGNMENT = exports.LEFT_ALIGNMENT = exports.SortableProperties = exports.htmlIdGenerator = exports.comboBoxKeyCodes = exports.cascadingMenuKeyCodes = exports.accessibleClickKeys = exports.keyCodes = undefined;

var _accessibility = require('./accessibility');

Object.defineProperty(exports, 'accessibleClickKeys', {
  enumerable: true,
  get: function get() {
    return _accessibility.accessibleClickKeys;
  }
});
Object.defineProperty(exports, 'cascadingMenuKeyCodes', {
  enumerable: true,
  get: function get() {
    return _accessibility.cascadingMenuKeyCodes;
  }
});
Object.defineProperty(exports, 'comboBoxKeyCodes', {
  enumerable: true,
  get: function get() {
    return _accessibility.comboBoxKeyCodes;
  }
});
Object.defineProperty(exports, 'htmlIdGenerator', {
  enumerable: true,
  get: function get() {
    return _accessibility.htmlIdGenerator;
  }
});

var _sort = require('./sort');

Object.defineProperty(exports, 'SortableProperties', {
  enumerable: true,
  get: function get() {
    return _sort.SortableProperties;
  }
});

var _alignment = require('./alignment');

Object.defineProperty(exports, 'LEFT_ALIGNMENT', {
  enumerable: true,
  get: function get() {
    return _alignment.LEFT_ALIGNMENT;
  }
});
Object.defineProperty(exports, 'RIGHT_ALIGNMENT', {
  enumerable: true,
  get: function get() {
    return _alignment.RIGHT_ALIGNMENT;
  }
});

var _key_codes = require('./key_codes');

var keyCodes = _interopRequireWildcard(_key_codes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

exports.keyCodes = keyCodes; /*
                              * Licensed to Elasticsearch B.V. under one or more contributor
                              * license agreements. See the NOTICE file distributed with
                              * this work for additional information regarding copyright
                              * ownership. Elasticsearch B.V. licenses this file to you under
                              * the Apache License, Version 2.0 (the "License"); you may
                              * not use this file except in compliance with the License.
                              * You may obtain a copy of the License at
                              *
                              *    http://www.apache.org/licenses/LICENSE-2.0
                              *
                              * Unless required by applicable law or agreed to in writing,
                              * software distributed under the License is distributed on an
                              * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
                              * KIND, either express or implied.  See the License for the
                              * specific language governing permissions and limitations
                              * under the License.
                              */

// Export all keyCodes under a `keyCodes` named variable
